------------------------------------------------------------
IF 0 = (SELECT count(*) from [sysobjects] where ([xtype] = 'U' or [xtype] = 'V') and [name] = 'ut_OCServer')
BEGIN
CREATE TABLE [dbo].[ut_OCServer]
(
   [RecId]  integer NOT NULL
  ,[MandId] integer DEFAULT 1
  ,[Code] char(20) DEFAULT ' '
  ,[Kennung] char(20) DEFAULT ' '
  ,[BaseUri] char(120) DEFAULT ' '
  ,[Active] tinyint DEFAULT 0
  CONSTRAINT [Pk_OCServer]  PRIMARY KEY NONCLUSTERED ( [RecId] )
)
END
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'TR'   and [name] = 'tr_OCServer_KeyDel')
  DROP TRIGGER [dbo].[tr_OCServer_KeyDel]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'TR'   and [name] = 'tr_OCServer_KeyUpd')
  DROP TRIGGER [dbo].[tr_OCServer_KeyUpd]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'U' and [name] = 'ut_OCServer_Keys')
  DROP TABLE [dbo].[ut_OCServer_Keys]
GO

IF 0 = (select count(*) from syscolumns sc inner join sysobjects so
        on sc.[id] = so.[id] and so.[name] = 'ut_OCServer' and sc.[name] = 'Code')
BEGIN
  ALTER TABLE [dbo].[ut_OCServer] ADD [Code] char(20) NOT NULL DEFAULT ' '
END
GO
IF 0 = (select count(*) from syscolumns sc inner join sysobjects so
        on sc.[id] = so.[id] and so.[name] = 'ut_OCServer' and sc.[name] = 'Kennung')
BEGIN
  ALTER TABLE [dbo].[ut_OCServer] ADD [Kennung] char(20) NOT NULL DEFAULT ' '
END
GO
IF 0 = (select count(*) from syscolumns sc inner join sysobjects so
        on sc.[id] = so.[id] and so.[name] = 'ut_OCServer' and sc.[name] = 'BaseUri')
BEGIN
  ALTER TABLE [dbo].[ut_OCServer] ADD [BaseUri] char(120) NOT NULL DEFAULT ' '
END
GO
IF 0 = (select count(*) from syscolumns sc inner join sysobjects so
        on sc.[id] = so.[id] and so.[name] = 'ut_OCServer' and sc.[name] = 'Active')
BEGIN
  ALTER TABLE [dbo].[ut_OCServer] ADD [Active] tinyint NOT NULL DEFAULT 0
END
GO
IF 20 > (select length from syscolumns sc inner join sysobjects so
        on sc.[id] = so.[id] and so.[name] = 'ut_OCServer' and sc.[name] = 'Code')
BEGIN
  ALTER TABLE [dbo].[ut_OCServer] ALTER COLUMN [Code] char(20)
END
GO
IF 20 > (select length from syscolumns sc inner join sysobjects so
        on sc.[id] = so.[id] and so.[name] = 'ut_OCServer' and sc.[name] = 'Kennung')
BEGIN
  ALTER TABLE [dbo].[ut_OCServer] ALTER COLUMN [Kennung] char(20)
END
GO
IF 120 > (select length from syscolumns sc inner join sysobjects so
        on sc.[id] = so.[id] and so.[name] = 'ut_OCServer' and sc.[name] = 'BaseUri')
BEGIN
  ALTER TABLE [dbo].[ut_OCServer] ALTER COLUMN [BaseUri] char(120)
END
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'V' and [name] = 'OCServer')
  DROP VIEW [dbo].[OCServer]
GO
CREATE VIEW [dbo].[OCServer] AS
  SELECT * FROM [dbo].[ut_OCServer]
GO
CREATE TABLE [dbo].[ut_OCServer_Keys]
(
   [DataRecId]  integer NOT NULL
  ,[DataMandId] integer DEFAULT 1
  ,[Key00_Value] CHAR(30) NOT NULL
  CONSTRAINT [Pk_ut_OCServer_Keys]  PRIMARY KEY NONCLUSTERED ( [DataRecId] )
)
GO
CREATE TRIGGER [dbo].[tr_OCServer_KeyDel] ON [dbo].[ut_OCServer]
FOR DELETE
AS
  SET NOCOUNT ON
  DELETE FROM [dbo].[ut_OCServer_Keys] WITH (SERIALIZABLE)
  WHERE [DataRecId] IN (SELECT [RecId] FROM DELETED)
GO

CREATE TRIGGER [dbo].[tr_OCServer_KeyUpd] ON [dbo].[ut_OCServer]
FOR INSERT, UPDATE
AS
  SET NOCOUNT ON
  IF UPDATE([RecId]) OR UPDATE([MandId])
  BEGIN
    DELETE FROM [dbo].[ut_OCServer_Keys] WITH (SERIALIZABLE)
    WHERE [DataRecId] IN (SELECT [RecId] FROM DELETED)

    INSERT INTO [dbo].[ut_OCServer_Keys] WITH (SERIALIZABLE)
    ([DataRecId],[DataMandId],[Key00_Value])
    (SELECT [RecId],[MandId]
     ,UPPER(convert(char(20),[Code])+STR(RecId,10))

    FROM INSERTED)
  END
  ELSE
  BEGIN
    UPDATE [dbo].[ut_OCServer_Keys] WITH (SERIALIZABLE) SET
    [Key00_Value] = UPPER(convert(char(20),[Code])+STR([RecId],10))
    FROM INSERTED WHERE [DataRecId] = [RecId]
  END
GO

UPDATE [dbo].[ut_OCServer] SET RecId = RecId
GO


------------------------------------------------------------
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Add_OCServer')
  DROP PROCEDURE [dbo].[up_Add_OCServer]
GO
CREATE PROCEDURE [dbo].[up_Add_OCServer] AS
  DECLARE @NeueId integer
  SET @NeueId = (SELECT MAX(RecId) from [dbo].[ut_OCServer])
  IF @NeueId IS NULL SET @NeueId = 0
  SET @NeueId = @NeueId + 1
  INSERT INTO [dbo].[ut_OCServer] (RecId) VALUES( @NeueId )
  IF @@ERROR = 0
  BEGIN
    SELECT @NeueId AS RecId
    RETURN
  END
  SELECT 0 AS RecId
GO

------------------------------------------------------------
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Upd_OCServer')
  DROP PROCEDURE [dbo].[up_Upd_OCServer]
GO
CREATE PROCEDURE [dbo].[up_Upd_OCServer]
  @RI integer
 ,@Parm_Code char(20)
 ,@Parm_Kennung char(20)
 ,@Parm_BaseUri char(120)
 ,@Parm_Active tinyint
AS
--BEGIN TRANSACTION
UPDATE [dbo].[ut_OCServer] SET
     [Code] = RTRIM(@Parm_Code)
    ,[Kennung] = RTRIM(@Parm_Kennung)
    ,[BaseUri] = RTRIM(@Parm_BaseUri)
    ,[Active] = @Parm_Active
  WHERE RecId = @RI
--COMMIT TRANSACTION
GO

------------------------------------------------------------
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Sel_OCServer')
  DROP PROCEDURE [dbo].[up_Sel_OCServer]
GO
CREATE PROCEDURE [dbo].[up_Sel_OCServer]
  @RI integer
AS
SELECT
     [Code]
    ,[Kennung]
    ,[BaseUri]
    ,[Active]
  FROM [dbo].[ut_OCServer]
  WHERE RecId = @RI
GO
------------------------------------------------------------
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Del_OCServer')
  DROP PROCEDURE [dbo].[up_Del_OCServer]
GO
CREATE PROCEDURE [dbo].[up_Del_OCServer]
  @RI integer
AS
  DELETE FROM [dbo].[ut_OCServer] WHERE RecId = @RI
GO
------------------------------------------------------------
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Reorg_OCServer')
  DROP PROCEDURE [dbo].[up_Reorg_OCServer]
GO
CREATE PROCEDURE [dbo].[up_Reorg_OCServer]
  @bDbcc integer,@bRecId integer
AS
  IF (@bRecId = 1)
  BEGIN
    DECLARE  C        CURSOR FOR SELECT RecId FROM [dbo].[ut_OCServer] ORDER BY RecId
    DECLARE  @CurrId  integer
    DECLARE  @NextId  integer
    --BEGIN TRANSACTION
    OPEN C
    SET @NextId = 1
    FETCH NEXT FROM C INTO @CurrId
    WHILE (@@FETCH_STATUS = 0)
    BEGIN
      IF @CurrId <> @NextId
      UPDATE [dbo].[ut_OCServer] SET RecId=@NextId WHERE CURRENT OF C
      SET @NextId = @NextId + 1
      FETCH NEXT FROM C INTO @CurrId
    END
    CLOSE C
    --COMMIT TRANSACTION
    DEALLOCATE C
  END

  IF (@bDbcc = 1)
  BEGIN
    DBCC DBREINDEX ( [ut_OCServer] )
  END

GO

------------------------------------------------------------
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Append_OCServer')
  DROP PROCEDURE [dbo].[up_Append_OCServer]
GO
CREATE PROCEDURE [dbo].[up_Append_OCServer]
  @Parm_Code char(20)
 ,@Parm_Kennung char(20)
 ,@Parm_BaseUri char(120)
 ,@Parm_Active tinyint
AS
  DECLARE @NeueId    integer
  SET     @NeueId = (SELECT MAX(RecId) FROM [dbo].[ut_OCServer])
  IF @NeueId IS NULL SET @NeueId = 0
  SET @NeueId = @NeueId + 1
  INSERT INTO [dbo].[ut_OCServer] (
    RecId
   ,[Code]
   ,[Kennung]
   ,[BaseUri]
   ,[Active]
     ) VALUES (
    @NeueId
   ,RTRIM(@Parm_Code)
   ,RTRIM(@Parm_Kennung)
   ,RTRIM(@Parm_BaseUri)
   ,@Parm_Active
       )
  IF @@ERROR = 0
  BEGIN
    SELECT @NeueId AS RecId
    RETURN
  END
  SELECT 0 AS RecId
GO

------------------------------------------------------------
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_TrSel_OCServer')
  DROP PROCEDURE [dbo].[up_TrSel_OCServer]
GO
CREATE PROCEDURE [dbo].[up_TrSel_OCServer]
AS
  SELECT   RecId,
      LTRIM(RTRIM([Code]))
      +LTRIM(RTRIM([Kennung]))
      +LTRIM(RTRIM([BaseUri]))
    AS Data
  FROM     [dbo].[ut_OCServer]
  WHERE    RecId > 0
  ORDER BY RecId
GO

CREATE INDEX [Ik_Key00] ON [dbo].[ut_OCServer_Keys]
( [Key00_Value],[DataRecId] )
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_First_OCServer_Key00')
  DROP PROCEDURE [dbo].[up_First_OCServer_Key00]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Last_OCServer_Key00')
  DROP PROCEDURE [dbo].[up_Last_OCServer_Key00]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Prior_OCServer_Key00')
  DROP PROCEDURE [dbo].[up_Prior_OCServer_Key00]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Next_OCServer_Key00')
  DROP PROCEDURE [dbo].[up_Next_OCServer_Key00]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Prior50_OCServer_Key00')
  DROP PROCEDURE [dbo].[up_Prior50_OCServer_Key00]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_Next50_OCServer_Key00')
  DROP PROCEDURE [dbo].[up_Next50_OCServer_Key00]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_FindL_OCServer_Key00')
  DROP PROCEDURE [dbo].[up_FindL_OCServer_Key00]
GO
IF 0 < (SELECT count(*) from [sysobjects] where [xtype] = 'P'   and [name] = 'up_FindF_OCServer_Key00')
  DROP PROCEDURE [dbo].[up_FindF_OCServer_Key00]
GO

CREATE PROCEDURE [dbo].[up_First_OCServer_Key00]
AS
  SELECT TOP 1 [DataRecId] FROM [dbo].[ut_OCServer_Keys] ORDER BY [Key00_Value]
GO

CREATE PROCEDURE [dbo].[up_Last_OCServer_Key00]
AS
  SELECT TOP 1 [DataRecId] FROM [dbo].[ut_OCServer_Keys] ORDER BY [Key00_Value] DESC
GO

CREATE PROCEDURE [dbo].[up_Next_OCServer_Key00] @mRecNo integer
AS
  SELECT TOP 1 [DataRecId] FROM [dbo].[ut_OCServer_Keys]
  WHERE [Key00_Value] > (SELECT [Key00_Value] FROM [dbo].[ut_OCServer_Keys] WHERE [DataRecId] = @mRecNo)
  ORDER BY [Key00_Value]
GO

CREATE PROCEDURE [dbo].[up_Prior_OCServer_Key00] @mRecNo integer
AS
  SELECT TOP 1 [DataRecId] FROM [dbo].[ut_OCServer_Keys]
  WHERE [Key00_Value] < (SELECT [Key00_Value] FROM [dbo].[ut_OCServer_Keys] WHERE [DataRecId] = @mRecNo)
  ORDER BY [Key00_Value] DESC
GO

CREATE PROCEDURE [dbo].[up_Next50_OCServer_Key00] @mRecNo integer
AS
  SELECT TOP 50 [DataRecId] FROM [dbo].[ut_OCServer_Keys]
  WHERE [Key00_Value] > (SELECT [Key00_Value] FROM [dbo].[ut_OCServer_Keys] WHERE [DataRecId] = @mRecNo)
  ORDER BY [Key00_Value]
GO

CREATE PROCEDURE [dbo].[up_Prior50_OCServer_Key00] @mRecNo integer
AS
  SELECT TOP 50 [DataRecId] FROM [dbo].[ut_OCServer_Keys]
  WHERE [Key00_Value] < (SELECT [Key00_Value] FROM [dbo].[ut_OCServer_Keys] WHERE [DataRecId] = @mRecNo)
  ORDER BY [Key00_Value] DESC
GO

CREATE PROCEDURE [dbo].[up_FindF_OCServer_Key00] @xKey char(128),@xLen integer
AS
  SELECT a.[DataRecId] FROM
    ( SELECT TOP 1 [DataRecId],[Key00_Value] AS Key_Value FROM [dbo].[ut_OCServer_Keys]
      WHERE [Key00_Value] >= SUBSTRING(@xKey,1,@xLen)
      ORDER BY [Key00_Value]
    ) a
  WHERE a.Key_Value like SUBSTRING(@xKey,1,@xLen)+'%'
GO

CREATE PROCEDURE [dbo].[up_FindL_OCServer_Key00] @xKey char(128),@xLen integer
AS
  SELECT TOP 1 [DataRecId] FROM [dbo].[ut_OCServer_Keys]
  WHERE [Key00_Value] like SUBSTRING(@xKey,1,@xLen)+'%'
  ORDER BY [Key00_Value] DESC
GO

